
// RandomRecord.CPP
//
//
// Generates random inputs for mp1: command line: num (of input integers)

//
//  ... 2 inserts, each with num+-10% input
//  ... sort after each insert
//  ... num*25% deletes
//  ... a final sort
//  
// garbage collection is _not_ explicitly tested (insert should take care of that).
// 
//
// no testing of print: can be too scary
// 

#include <stdlib.h>
#include <stdio.h>

#include "RandNum.h"

void TestRound(int num);

void main( int argc, char **argv )
{
   	int num;

   	if (argc != 2) {
        fprintf(stderr, "Usage: %s <Num Keys>\n", argv[0]);
		exit(1);
   	}

	sscanf(argv[1], "%d", &num);
	
	TestRound(num);	// insert num, sort, delete about 25%, 
	TestRound(num);
	printf("s\n");
	printf("q\n");
}

void TestRound(int num)
{
	// now insert "num"
	int numToInsert = int(num * RandomNumber(0.9f, 1.1f));
	int *a = new int[numToInsert];

   	fprintf(stderr, "Going to insert: %d number of keys\n", numToInsert);
   	//
   	// creating for mp1 input ...
   	printf("i\n");	// inseret command
   	for (int i=0; i<numToInsert; i++) {
		a[i] = RandomNumber();
		printf("%d\n", a[i]);
	}
	printf("-1\n");
   	printf("s\n");	// sort command
   	

	int numToDelete = int(num * RandomNumber(0.2f, 0.3f));
   	fprintf(stderr, "Going to delete: %d number of keys\n", numToDelete);
	//
	for (i=0; i<numToDelete; i++) {
		int index = RandomNumber(0, numToInsert-1);
		printf("d %d\n", a[index]);
	}

}
